#include <string.h>
#include <stdio.h>

#define EXPORT __declspec(dllexport)
#define EXTRA 


EXPORT int EXTRA LC_GetExtension(char* ext, int maxlen)
{
  strncpy(ext,"Raw map file (*.map)|*.map|",maxlen);
  return 0;
}

FILE* f=NULL;
FILE* flog=NULL;
int maxlayers;
int layer;
int size_x,size_y;

EXPORT int EXTRA LC_SaveHeader(char* filename, char* tilesfile, int cx, int cy, int layers)
{
  int len;
  if (flog==NULL) flog=fopen("plug1.log","a");
  fprintf(flog,"Got in to SaveHeader\n");
  fclose(flog); flog=NULL;
  if (f!=NULL) return -1;
  f=fopen(filename,"wb");
  if (f==NULL) return -1;
  size_x=cx;
  size_y=cy;
  maxlayers=layers;
  layer=0;
  len=strlen(tilesfile);
  fwrite(&len,4,1,f);
  if (len>0)
    fwrite(tilesfile,1,len,f);
  fwrite(&cx,4,1,f);
  fwrite(&cy,4,1,f);
  fwrite(&layers,4,1,f);
  return 1;
}

EXPORT int EXTRA LC_SaveLayer(int handle, char* name, int visible, int* tiles)
{
  int len,x,y,tile;
  if (f==NULL || handle!=1) return -1;
  len=strlen(name);
  fwrite(&len,4,1,f);
  fwrite(name,1,len,f);
  fwrite(&visible,4,1,f);
  // faster and simpler is  fwrite(tiles,4,size_x*size_y,f);
  // but this will show how to access each tile.
  for(y=0;y<size_y;y++)
  {
    for(x=0;x<size_x;x++)
    {
      tile=tiles[y*size_x+x];
      fwrite(&tile,4,1,f);
    }
  }
  if (++layer == maxlayers)
  {
    // last layer, close the file
    fclose(f);
    f=NULL;
    return 0;
  }
  return handle;
}

