#include <stdio.h>

#define EXPORT __declspec(dllexport)

/* Basic Plugin DLL */

char* Description = "My map file";
char* Extension   = "mym";

/* Plugin format information retrieval */
EXPORT int LC_GetExtension(char* ext, int maxlen)
{
  char buf[256];
  sprintf(buf,"%s (*.%s)|(*.%s)|",Description,Extension,Extension);
  strncpy(ext,buf,maxlen);
  return 0;
}

/* Initialize export.  Called once per export. */
EXPORT int LC_SaveHeader(char* filename, char* tilesfile, int cx, int cy, int layers)
{
  /* Initialize the export process. */
  int error=0;
  int handle=1;  /* >0 indicates success and identifies this export */

  if (error) return -1; /* Failure */
  return handle;
}

/* Save layer information.  Called once per layer. */
EXPORT int LC_SaveLayer(int handle, char* name, int visible, int* tiles)
{
  int error=0;
  /* Save the layer info */

  /* if this is the last layer (number was given in header)
     you should close your output and finalize. */

  if (error) return -1;
  return handle; /* success */
}
